const BaseMethods = {
  /**
   * 获取数据类型
   * @param params
   * @returns 'String','Number'...
   */
  getTypeOf: params => {
    let type = Object.prototype.toString.call(params)
    return type.match(/\[\w+\W(\w+)\]$/)[1]
  },
  /**
   * 数组，字符串去重
   * @param Array,String
   * @returns
   */
  unique: params => {
    if (this.getTypeOf(params) === 'Array') {
      return [...new Set(arr)]
    }
    if (this.getTypeOf(params) === 'String') {
      let obj = {}
      let str = ''
      for (let i = 0, len = params.length; i < len; i++) {
        if (obj[params[i]]) {
          str += params[i]
          obj[params[i]] = true
        }
      }
      return str
    }
  },
  /**
   * 加法 乘法精度计算
   * js数值计算 示例：funCalc([1.02,3,4])
   * @param {*} arrList 参数数组
   * @param {*} operator 操作符：1加法 2乘法
   * @param {*} precision 精度 默认2位
   */
  funCalc: (arrList, operator = 1, precision = 2) => {
    if (arrList.length === 0) return 0
    // 计算最大数度值,避免精度丢失，先扩大位数，再缩小
    let mPow = Math.pow(10, precision) // 默认2位小数
    let total = 0
    if (operator == 2) {
      total = 1
      mPow = 1
    }
    for (const item of arrList) {
      let tem = 0
      if (item) {
        tem = parseFloat(item) ?? 0 // parseFloat转化失败的情况
        tem = !isNaN(tem) ? tem : 0 // 处理 NaN
      }
      switch (operator) {
        case 1:
          total += tem * mPow
          break
        case 2:
          total *= tem * mPow
          break
        default:
          total += tem * mPow
      }
    }
    const res = (total / mPow).toFixed(precision)
    return res
  }
}

export default BaseMethods
